freeze;

/////////////////////////////////////////////////////////////////////////
// syslog.m
/////////////////////////////////////////////////////////////////////////
// $Revision: 34307 $
// $Date: 2011-07-09 15:51:17 +0100 (Sat, 09 Jul 2011) $
// $LastChangedBy: kasprzyk $
/////////////////////////////////////////////////////////////////////////
// Author: Alexander Kasprzyk
/////////////////////////////////////////////////////////////////////////
// Allows logging to the syslog.
/////////////////////////////////////////////////////////////////////////

import "pipes.m": escape_string, pipe_command;
import "logger.m": set_logger;

/////////////////////////////////////////////////////////////////////////
// Local functions
/////////////////////////////////////////////////////////////////////////

// Logs the given message to the syslog.
procedure syslog_logger_handler(message,level)
    cmd:="syslog -s -k" cat
            " Level " cat IntegerToString(7 - level) cat
            " Sender Magma " cat
            " Message \"" cat escape_string(message) cat "\"";
    if not pipe_command(cmd) then
        print "Warning: Unable to log message with syslog";
    end if;
end procedure;

/////////////////////////////////////////////////////////////////////////
// Intrinsics
/////////////////////////////////////////////////////////////////////////

intrinsic SetLoggerToSyslog()
{Sets log messages to be saved to the syslog, and enables logging.}
    require pipe_command("syslog --help"):
        "This computer does not support the syslog";
    set_logger(syslog_logger_handler,"%s");
end intrinsic;
